﻿using System;
using System.Collections.Generic;
using System.Text;
using OSGeo.FDO.Connections;
using OSGeo.FDO.ClientServices;
using System.Diagnostics;

namespace PostgresTest
{
    class Program
    {
        static void Main(string[] args)
        {
            string username = ""; //fill in
            string password = ""; //fill in
            string service = ""; //fill in
            string datastore = ""; //fill in

            IConnection conn = FeatureAccessManager.GetConnectionManager().CreateConnection("OSGeo.PostgreSQL");

            string connStr = string.Format("Username={0};Password={1};Service={2};DataStore={3}",
                username,
                password,
                service,
                datastore);
            conn.ConnectionString = connStr;

            conn.Open();
            Debug.Assert(conn.ConnectionState == ConnectionState.ConnectionState_Open);
            conn.Close();
            Debug.Assert(conn.ConnectionState == ConnectionState.ConnectionState_Closed);

            try
            {
                //Uncomment the fragment below and no exception is thrown.
                //conn.ConnectionString = connStr;

                conn.Open();
                Debug.Assert(conn.ConnectionState == ConnectionState.ConnectionState_Open);
                conn.Close();
            }
            catch (OSGeo.FDO.Common.Exception ex)
            {
                Debug.WriteLine(ex.ToString());
                Debug.Fail("We're re-opening connection w/ same connection string. OMGWTFBBQ!?");
            }
            finally
            {
                conn.Dispose();
            }
        }
    }
}
